#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>
#include <stdio.h>
#include <iostream.h>
#include <dos.h>
#include <ctype.h>
#include <time.h>
#include "svgacc.h"

RasterBlock *tile[30];
RasterBlock *blkdata;
RasterBlock *tile2[30];
RasterBlock *num[10];
RasterBlock *num2[10];
RasterBlock *flag[5];
RasterBlock *flag2[5];
RasterBlock *walkable;


int tilepos=1;
char TileSet;
char tilefile[]="tiles.dat";
int locx, locy, loctype;
int offsetx, offsety;

struct MapInfo {  //Map Tiles and Flags
	int tile;
	int flag;
} Map[100][100];

void SetGraphicsMode(void);
void LoadPCX(void);
void GrabTiles(void);
void DrawMap(void);
void CleanUp(void);
void DrawTiles(void);
void MoveLoc(void);
void ChangeTile(void);
void DrawOffset(void);
void SaveFile(void);
void LoadFile(void);
void DisplayNum(void);
void DrawGraphicEditor(void);
void Help(void);

void SetGraphicsMode(void) {
	if ( !whichvga() || (whichmem() < 512))
		exit(1);
		res640();
}

void LoadPCX(char fname[]=tilefile) {
	int xsize,ysize,numcol,ok;
	int i,darkcolor,britecolor,currcolor;
	PaletteData pcxpal;

	ok=pcxgetinfo(fname,&xsize,&ysize,&numcol,pcxpal);
	if(ok==1) {
		if(!res640())
			exit(1);
		darkcolor=0+0+0;
	};
	britecolor=63+63+63;
	for(i=0;i<255;i++) {
		pcxpal[i].r>>=2;
		pcxpal[i].g>>=2;
		pcxpal[i].b>>=2;
		currcolor=pcxpal[i].r + pcxpal[i].g + pcxpal[i].b;
		if(currcolor > darkcolor)
			darkcolor=currcolor;
		if(currcolor < britecolor)
			britecolor=currcolor;
	};
	palset(pcxpal,0,255);
	fillscreen(darkcolor);
};

void SaveFile() {
	FILE* iFile;
	if ((iFile = fopen("MAP.DAT", "wb")) == NULL) /* open file TEST.$$$ */
	{
		fprintf(stderr, "Cannot open output file.\n");
	}
	fwrite(&Map,sizeof(Map),1,iFile);     //Read the entire map into the struct
	fclose(iFile);
};

void LoadFile() {
	FILE* oFile;
	if ((oFile = fopen("MAP.DAT", "rb"))  == NULL)
	{
		fprintf(stderr, "Cannot open output file.\n");
	}
	fread(&Map,sizeof(Map),1,oFile);     //Read the entire map into the struct
	fclose(oFile);
	DrawOffset();
};


void GrabTiles(RasterBlock *tile[100], RasterBlock *tile2[100], char fname[]=tilefile ) {
		pcxput(SET,1,1,fname);
		int tiletemp;
		for(tiletemp=0;tiletemp<20;tiletemp++) {		//Main Landscape Tileset
			tile2[tiletemp] = (RasterBlock *)malloc((18)*(18)+4);
//			tile2[tiletemp] = (RasterBlock *)xmsallocate(30);
			blkget(1+(18*tiletemp),1,18+(18*tiletemp),18,tile2[tiletemp]);
		}
		for(tiletemp=0;tiletemp<20;tiletemp++) {		//Enlarged Main Landscape Tileset
			tile[tiletemp] = (RasterBlock *)malloc((25)*(25)+4);
//			tile[tiletemp] = (RasterBlock *)xmsallocate(30);
			blkresize(25,25,tile2[tiletemp],tile[tiletemp]);
			free(tile2[tiletemp]);
		}
		for(tiletemp=0;tiletemp<10;tiletemp++) {		//Numbers 0 - 9
			num2[tiletemp] = (RasterBlock *)malloc((7)*(11)+4);
			blkget(1+(7*tiletemp),30,7+(7*tiletemp),40,num2[tiletemp]);
		}
		for(tiletemp=0;tiletemp<10;tiletemp++) {		//Enlarged numbers 0 - 9
			num[tiletemp] = (RasterBlock *)malloc((14)*(22)+4);
			blkresize(14,22,num2[tiletemp],num[tiletemp]);
			free(num2[tiletemp]);
		}
		for(tiletemp=0;tiletemp<2;tiletemp++) {                    //Green and Red Light Walkable
			flag2[tiletemp] = (RasterBlock *)malloc((15)*(10)+4);
			blkget(1+(15*tiletemp),50,15+(15*tiletemp),58,flag2[tiletemp]);
		}
		for(tiletemp=0;tiletemp<2;tiletemp++) {						// Enlarged Green and Red Light Walkable
			flag[tiletemp] = (RasterBlock *)malloc((30)*(19)+4);
			blkresize(30,19,flag2[tiletemp],flag[tiletemp]);
			free(flag2[tiletemp]);
		}
			walkable = (RasterBlock *)malloc((70)*(11)+4);
			blkget(2,66,69,75,walkable);		//Walkable Sign
};

void DrawMap(RasterBlock *tile[100]) {
	int tempx;
	int tempy;
	int tempx2;
	int tempy2;
	fillscreen(BLACK);
	for(tempy=25;tempy<350;tempy+=25) {
		for(tempx=25;tempx<650;tempx+=25) {
			blkput(1,tempx-25,tempy-25,tile[Map[((tempx/25)+offsetx)-1][((tempy/25)+offsety)-1].tile]);
		}
	}
};

void DrawTiles(RasterBlock *tile[100], int tilepos) {
	int tempx;
	for(tempx=25;tempx<(25*21);tempx+=25) {
		blkput(1,tempx-25,400,tile[(tempx/25)-1]);
	}
	switch(tilepos) {
		case 0 :
			drwline(1,GREEN,0,427,25,427);
			drwline(1,BLACK,25,427,50,427);
			break;
		case 1 :
			drwline(1,BLACK,0,427,25,427);
			drwline(1,GREEN,25,427,50,427);
			drwline(1,BLACK,50,427,75,427);
			break;
		case 2 :
			drwline(1,BLACK,25,427,50,427);
			drwline(1,GREEN,50,427,75,427);
			drwline(1,BLACK,75,427,100,427);
			break;
		case 3 :
			drwline(1,BLACK,50,427,75,427);
			drwline(1,GREEN,75,427,100,427);
			drwline(1,BLACK,100,427,125,427);
			break;
		case 4 :
			drwline(1,BLACK,75,427,100,427);
			drwline(1,GREEN,100,427,125,427);
			drwline(1,BLACK,125,427,150,427);
			break;
		case 5 :
			drwline(1,BLACK,100,427,125,427);
			drwline(1,GREEN,125,427,150,427);
			drwline(1,BLACK,150,427,175,427);
			break;
		case 6 :
			drwline(1,BLACK,125,427,150,427);
			drwline(1,GREEN,150,427,175,427);
			drwline(1,BLACK,175,427,200,427);
			break;
		case 7 :
			drwline(1,BLACK,150,427,175,427);
			drwline(1,GREEN,175,427,200,427);
			drwline(1,BLACK,200,427,225,427);
			break;
		case 8 :
			drwline(1,BLACK,175,427,200,427);
			drwline(1,GREEN,200,427,225,427);
			drwline(1,BLACK,225,427,250,427);
			break;
		case 9 :
			drwline(1,BLACK,200,427,225,427);
			drwline(1,GREEN,225,427,250,427);
			drwline(1,BLACK,250,427,275,427);
			break;
		case 10 :
			drwline(1,BLACK,225,427,250,427);
			drwline(1,GREEN,250,427,275,427);
			drwline(1,BLACK,275,427,300,427);
			break;
		case 11 :
			drwline(1,BLACK,250,427,275,427);
			drwline(1,GREEN,275,427,300,427);
			drwline(1,BLACK,300,427,325,427);
			break;
		case 12 :
			drwline(1,BLACK,275,427,300,427);
			drwline(1,GREEN,300,427,325,427);
			drwline(1,BLACK,325,427,350,427);
			break;
		case 13 :
			drwline(1,BLACK,300,427,325,427);
			drwline(1,GREEN,325,427,350,427);
			drwline(1,BLACK,350,427,375,427);
			break;
		case 14 :
			drwline(1,BLACK,325,427,350,427);
			drwline(1,GREEN,350,427,375,427);
			drwline(1,BLACK,375,427,400,427);
			break;
		case 15 :
			drwline(1,BLACK,350,427,375,427);
			drwline(1,GREEN,375,427,400,427);
			drwline(1,BLACK,400,427,425,427);
			break;
		case 16 :
			drwline(1,BLACK,375,427,400,427);
			drwline(1,GREEN,400,427,425,427);
			drwline(1,BLACK,425,427,450,427);
			break;
		case 17 :
			drwline(1,BLACK,400,427,425,427);
			drwline(1,GREEN,425,427,450,427);
			drwline(1,BLACK,450,427,475,427);
			break;
		case 18 :
			drwline(1,BLACK,425,427,450,427);
			drwline(1,GREEN,450,427,475,427);
			drwline(1,BLACK,475,427,500,427);
			break;
		case 19 :
			drwline(1,BLACK,450,427,475,427);
			drwline(1,GREEN,475,427,500,427);
			drwline(1,BLACK,500,427,525,427);
			break;
/*		case 20 :
			drwline(1,BLACK,475,427,500,427);
			drwline(1,GREEN,500,427,525,427);
			drwline(1,BLACK,525,427,550,427);
			break; */
	};
};

void DisplayNum(void) {
/*	int temper;
	for(temper=0;temper<10;temper++) {
		blkput(SET,490+(temper*14),450,num[temper]);
	}*/
};

void MoveLoc(void) {
	blkput(1,locx*25,locy*25,tile[Map[locx+offsetx][locy+offsety].tile]);
	switch(loctype) {
		case 3 :		// L key
			locx++;
			blkput(SET,567,345,flag[Map[locx+offsetx][locy+offsety].flag]);
			break;
		case 1 :		// J key
			locx--;
			blkput(SET,567,345,flag[Map[locx+offsetx][locy+offsety].flag]);
			break;
		case 2 :		// K key
			locy++;
			blkput(SET,567,345,flag[Map[locx+offsetx][locy+offsety].flag]);
			break;
		case 4 :		// I key
			locy--;
			blkput(SET,567,345,flag[Map[locx+offsetx][locy+offsety].flag]);
			break;
	}
	drwbox(1,RED,locx*25,locy*25,(locx*25)+24,(locy*25)+24);

};

void ChangeTile(void) {
	Map[locx+offsetx][locy+offsety].tile=tilepos;
	blkput(1,locx*25,locy*25,tile[Map[locx+offsetx][locy+offsety].tile]);
	drwbox(1,RED,locx*25,locy*25,(locx*25)+24,(locy*25)+24);
};

void DrawOffset(void) {
	int tempx;
	int tempy;
	for(tempy=25;tempy<350;tempy+=25) {
		for(tempx=25;tempx<650;tempx+=25) {
			blkput(1,tempx-25,tempy-25,tile[Map[((tempx/25)+offsetx)-1][((tempy/25)+offsety)-1].tile]);
		}
	}
	drwbox(1,RED,locx*25,locy*25,(locx*25)+24,(locy*25)+24);
	blkput(SET,567,345,flag[Map[locx+offsetx][locy+offsety].flag]);

};

void Help(void) {
	restext();
	printf("                                  Help Menu                              \n");
	printf("                                  ---------                              \n");
	printf("        Walk Status                              Tile Options            \n");
	printf("        -----------                              ------------            \n");
	printf("Q - Change tile walkable                A - Place selected tile          \n");
	printf("W - Change tile non-walkable            D - Move tile selector left      \n");
	printf("                                        F - Move tile selector right     \n");
	printf("                                                                         \n");
	printf("                                                                         \n");
	printf("         Moving around the map                      Z - Save file        \n");
	printf("         ---------------------                      X - Load file        \n");
	printf("               I - Move up                                               \n");
	printf("                                                                         \n");
	printf("J - Move left                 L - Move right                             \n");
	printf("                                                                         \n");
	printf("               K - Move down                                             \n");
	printf("                                                             			   \n");
	printf("* Use the numeric keypad to move 10 in any direction                     \n");
	printf("* ESC exits the program																	\n");
	printf("                                                                         \n");
	printf("                                                                         \n");
	printf("                       ** Press Any Key To Kontinue");
	getch();
};

void DrawGraphicEditor(void) {
	LoadPCX(tilefile);
	DrawMap(tile);
	DrawTiles(tile, tilepos);
	DisplayNum();
	blkput(SET,550,330,walkable);
	blkput(SET,567,345,flag[Map[locx+offsetx][locy+offsety].flag]);
	drwline(1,LIGHTCYAN,639,0,639,479);
	drwline(1,LIGHTCYAN,0,479,639,479);
	drwbox(1,LIGHTCYAN,489,449,631,472);
	drwbox(1,RED,locx*25,locy*25,(locx*25)+24,(locy*25)+24);
	drwline(1,GREEN,0,427,25,427);
};

void CleanUp(void) {
	restext();
	int blah;
	for(blah=0;blah<10;blah++) {
		free(num[blah]);
	}
	for(blah=0;blah<30;blah++) {
		free(tile[blah]);
	}
	for(blah=0;blah<5;blah++) {
		free(flag[blah]);
		free(walkable);
	}
};
