#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>
#include <stdio.h>
#include <iostream.h>
#include <dos.h>
#include <ctype.h>
#include <time.h>
#include "svgacc.h"

RasterBlock *tile[30];
RasterBlock *blkdata;
RasterBlock *tile2[30];
RasterBlock *num[10];
RasterBlock *num2[10];
RasterBlock *guy[4];
RasterBlock *guy2[4];


int tilepos=1;
int xsize,ysize,numcol,ok;
int i,darkcolor,britecolor,currcolor;
char TileSet;
char tilefile[]="tiles.dat";
int locx, locy, loctype;
int offsetx, offsety;
PaletteData pcxpal;

struct MapInfo {  //Map Tiles and Flags
	int tile;
	int flag;
} Map[100][100];

void SetGraphicsMode(void);
void LoadPCX(char *);		//Pretty much loads the pallate
void GrabTiles(void);	//Grabs the tiles into memory
void DrawMap(void);		//Draws the map
void CleanUp(void);		//Cleans up after a messy programmer (me)...Memory and such
void MoveLoc(void);
void ChangeTile(void);
void SaveFile(void);			//Saves the map file (prolly not needed in this program
void LoadFile(void);			//Loads the map file from binary file MAP.DAT
void DisplayNum(void);		//Displays the numbers 0-9 on the screen
void DrawGraphicEditor(void);		//Draws the Graphic Screen (ie- Beginning, after text help screen, etc)
void Help(void);				//Help screen!  Still the help screen for the editor...needs to be updated
void ShowLogo(void);		//Shows the logo for FF0.
void Credits(void);		//Shows the credits for FF0.
void PutBG(void); //Puts the background on the screen


void Credits(void) {
res320();
pcxput(SET,1,1,"credits.dat");		//Opens up the credits picture (in PCX)
getch();
};

void ShowLogo(void) {
res320();
pcxput(SET,1,1,"logo.dat");		//Opens up the logo picture (in PCX)
pcxput(SET,1,1,"logo.dat");		//Opens up the logo picture (in PCX)
getch();

};


void SetGraphicsMode(void) {
	if ( !whichvga() || (whichmem() < 512))
		exit(1);	  //this block of code just sets the graphics mode
		res640();  //to 640x480x256.  Not really needed as a seperate function,
					  //but i really don't care :)
}

void LoadPCX(char fname[]=tilefile) {
	ok=pcxgetinfo(fname,&xsize,&ysize,&numcol,pcxpal);
/*	if(ok==1) {
		if(!res640())
			exit(1);				//This function loads the tileset into memory and
		darkcolor=0+0+0;		//figures out what the pallate is.  Who knows how
	} */							//it works.  Taken from the example in SVGACC23.TXT
	darkcolor=0+0+0;
	britecolor=63+63+63;
	for(i=0;i<255;i++) {
		pcxpal[i].r>>=2;
		pcxpal[i].g>>=2;
		pcxpal[i].b>>=2;
		currcolor=pcxpal[i].r + pcxpal[i].g + pcxpal[i].b;
		if(currcolor > darkcolor)
			darkcolor=currcolor;
		if(currcolor < britecolor)
			britecolor=currcolor;
	}
	palset(pcxpal,0,255);
//	fillscreen(darkcolor);
};

void PutBG() {
	pcxput(SET,1,1,"bg.dat");
};

void SaveFile() {
	FILE* iFile;
	if ((iFile = fopen("MAP.DAT", "wb")) == NULL) // open file MAP.DAT
	{
		fprintf(stderr, "Cannot open output file.\n");
	}
	fwrite(&Map,sizeof(Map),1,iFile);     //Read the entire map into the struct
	fclose(iFile);
};

void LoadFile() {
	FILE* oFile;
	if ((oFile= fopen("MAP.DAT", "rb"))  == NULL)	  //Opens the file MAP.DAT
	{
		fprintf(stderr, "Cannot open output file.\n");
	}
	fread(&Map,sizeof(Map),1,oFile);     //Read the entire map into the struct
	fclose(oFile);
	DrawMap();	//ABC
};


void GrabTiles(RasterBlock *tile[100], RasterBlock *tile2[100], char fname[]=tilefile ) {
		res640();		//Change to 640x480
		pcxput(SET,1,1,fname);		//Display the tileset on the screen so we can hack it to bits
		int tiletemp;		//Just a simple temporary variable
		for(tiletemp=0;tiletemp<20;tiletemp++) {		//Main Landscape Tileset
			tile2[tiletemp] = (RasterBlock *)malloc((18)*(18)+4);		//Allocate memory for the tiles
			blkget(1+(18*tiletemp),1,18+(18*tiletemp),18,tile2[tiletemp]);   //Grab the tiles
		}
		for(tiletemp=0;tiletemp<20;tiletemp++) {		//Enlarged Main Landscape Tileset
			tile[tiletemp] = (RasterBlock *)malloc((25)*(25)+4);
			blkresize(25,25,tile2[tiletemp],tile[tiletemp]);
			free(tile2[tiletemp]);	//Free up the old variables...I NEED MORE MEMORY!!!!!!
		}
		for(tiletemp=0;tiletemp<10;tiletemp++) {		//Numbers 0 - 9
			num2[tiletemp] = (RasterBlock *)malloc((7)*(11)+4);
			blkget(1+(7*tiletemp),30,7+(7*tiletemp),40,num2[tiletemp]);
		}
		for(tiletemp=0;tiletemp<10;tiletemp++) {		//Enlarged numbers 0 - 9
			num[tiletemp] = (RasterBlock *)malloc((14)*(22)+4);
			blkresize(14,22,num2[tiletemp],num[tiletemp]);
			free(num2[tiletemp]);
		}
		for(tiletemp=0;tiletemp<3;tiletemp++) {		//Grab the 4 positions of the guy
			guy2[tiletemp] = (RasterBlock *)malloc((18)*(18)+4);	//guy2[3] is not working properly
			blkget(1+(18*tiletemp),77,18+(18*tiletemp),93,guy2[tiletemp]);
		}
		for(tiletemp=0;tiletemp<3;tiletemp++) {		//Enlarge the 4 positions of the guy
			guy[tiletemp] = (RasterBlock *)malloc((25)*(25)+4);
			blkresize(25,25,guy2[tiletemp],guy[tiletemp]);
			free(guy2[tiletemp]);
		}
			tile[21] = (RasterBlock *)malloc((20)*(20)+4);
			blkget(20,150,40,170,tile[21]);		//Status bar.  Going to require points 1,100,300,200.
															//Not enough memory currently.
};

//void DrawMap(RasterBlock *tile[100]) {
void DrawMap() {
	int tempx;
	int tempy;
	for(tempy=25;tempy<350;tempy+=25) {
		for(tempx=25;tempx<650;tempx+=25) {
			blkput(1,tempx-25,tempy-25,tile[Map[((tempx/25)+offsetx)-1][((tempy/25)+offsety)-1].tile]);
		}
	}
};


void DisplayNum(void) {
	int temper;
	for(temper=0;temper<10;temper++) {
		blkput(SET,490+(temper*14),450,num[temper]);
	}
};

void MoveLoc(void) {
//	blkput(1,locx*25,locy*25,tile[Map[locx+offsetx][locy+offsety].tile]);
	switch(loctype) {
		case 3 :		// L key
			if(Map[(locx+offsetx)+1][(locy+offsety)].flag==0) {
					blkput(SET,locx*25,locy*25,tile[Map[locx+offsetx][locy+offsety].tile]);
					locx++;
			}
			blkput(SET,locx*25,locy*25,guy[3]);
		break;

		case 1 :		// J key

			if(Map[(locx+offsetx)-1][(locy+offsety)].flag==0) {
					blkput(SET,locx*25,locy*25,tile[Map[locx+offsetx][locy+offsety].tile]);
					locx--;
			}
					blkput(SET,locx*25,locy*25,guy[2]);
		break;

		case 2 :		// K key
			if(Map[(locx+offsetx)][(locy+offsety)+1].flag==0) {
					blkput(SET,locx*25,locy*25,tile[Map[locx+offsetx][locy+offsety].tile]);
					locy++;
			}
					blkput(SET,locx*25,locy*25,guy[1]);
		break;

		case 4 :		// I key
			if(Map[(locx+offsetx)][(locy+offsety)-1].flag==0) {
					blkput(SET,locx*25,locy*25,tile[Map[locx+offsetx][locy+offsety].tile]);
					locy--;
			}
					blkput(SET,locx*25,locy*25,tile[2]);  //tile[2] cause guy[3] wasn't working
		break;
	}
};

void ChangeTile(void) {
	Map[locx+offsetx][locy+offsety].tile=tilepos;
	blkput(1,locx*25,locy*25,tile[Map[locx+offsetx][locy+offsety].tile]);
	drwbox(1,RED,locx*25,locy*25,(locx*25)+24,(locy*25)+24);
};

void Help(void) {
	restext();
	printf("                                  Help Menu                              \n");
	printf("                                  ---------                              \n");
	printf("        Walk Status                              Tile Options            \n");
	printf("        -----------                              ------------            \n");
	printf("Q - Change tile walkable                A - Place selected tile          \n");
	printf("W - Change tile non-walkable            D - Move tile selector left      \n");
	printf("                                        F - Move tile selector right     \n");
	printf("                                                                         \n");
	printf("                                                                         \n");
	printf("         Moving around the map                      Z - Save file        \n");
	printf("         ---------------------                      X - Load file        \n");
	printf("               I - Move up                                               \n");
	printf("                                                                         \n");
	printf("J - Move left                 L - Move right                             \n");
	printf("                                                                         \n");
	printf("               K - Move down                                             \n");
	printf("                                                             			   \n");
	printf("* Use the numeric keypad to move 10 in any direction                     \n");
	printf("* ESC exits the program																	\n");
	printf("                                                                         \n");
	printf("                                                                         \n");
	printf("                       ** Press Any Key To Kontinue");
	getch();
	res640();
};


void DrawGraphicEditor(void) {
	PutBG();
	LoadPCX(tilefile);
	DrawMap();
//	DisplayNum();
	blkput(SET,locx*25,locy*25,tile[2]);

};

void CleanUp(void) {
	restext();
	int blah;
	for(blah=0;blah<10;blah++) {
		free(num[blah]);
	}
	for(blah=0;blah<30;blah++) {
		free(tile[blah]);
	}
	for(blah=0;blah<3;blah++) {
		free(guy[blah]);
	}

};
